import * as Ts from './ts'
import mlui from './ml'
import * as Sql from '0.edsql.mysql/ts'
import mobz, { GetStore, SetStore } from 'mobz'
import { ipcRenderer } from 'electron'
export default class {
    _ipcName
    constructor(ipcName: number) {
        this._ipcName = ipcName.toString()
    }
    stateBase(): Pick<Ts.WebStore, 'tables' | 'error'> {
        const tables = {} as Ts.WebStore['tables']
        Object.keys((t: keyof Ts.Tables) => tables[t] = {})
        const error = {} as Ts.WebStore['error']
        return { tables, error }
    }
    stateOn = (op: Ts.On, getState: GetStore<Ts.WebStore>, setState: SetStore<Ts.WebStore>) => {
        switch (op.api) {
            case 'testconfig':
            // return getState().testconfig=op.res
            case 'setconfig':
                return setState(s => ({}))
            case 'delete':
                return setState(s => ({}))
            case 'insert':
                return setState(s => ({}))
            case 'update':
                return setState(s => ({}))
            case 'select':
                return setState(s => ({}))
            default:
            // throw new Error(op.api + '未定义接收方法')
        }
    }
    electron = (invoke: typeof ipcRenderer.invoke, on: typeof ipcRenderer.on) => {
        // return mobz<Ts.WebStore>((getState, setState) => {
        //     on(this._ipcName, (event, op) => {
        //         // if
        //         this.stateOn(op,getState, setState)
        //     })
        //     const send = {} as Ts.Send
        //     [...Sql.curdName,...Sql.poolName].forEach(api => send[api] = async (param: any) => {
        //         const res = await invoke(this._ipcName, { api, param })
        //         this.stateOn(res,getState,  setState)
        //         return res.success
        //     })
        //     const store = {
        //         ...this.stateCreate(),
        //         send,
        //         mlui:{}// new mlui(getState, setState),
        //     }
        //     return store
        // })
    }
    axios = () => { }

    socket = () => { }
}